<?php

/**
 * novedad_vencimiento actions.
 *
 * @package    cartera
 * @subpackage novedad_vencimiento
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class novedad_vencimientoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_NOVEDAD_VENCIMIENTO',
        'TS_TD'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'TS_TD' =>
        array(
            'id_ts_td-id' => 'CA_NOVEDAD_VENCIMIENTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_NOVEDAD_VENCIMIENTO' =>
        array(
            'id_novedad_vencimiento' => 'id_novedad_vencimiento',
            'id_debito' => 'id_debito',
            'fecha_vence_ant' => 'fecha_vence_ant',
            'fecha_vence_act' => 'fecha_vence_act',
            'num_doc' => 'num_doc',
            'id_ts_td' => 'id_ts_td',
            'fecha_novedad' => 'fecha_novedad',
            'observaciones' => 'observaciones',
            'usuariolog' => 'usuariolog',
            'fecha_log' => 'fecha_log',
            'observaciones_ant' => 'observaciones_ant',
            'observaciones_act' => 'observaciones_act'
        ),
        'TS_TD' =>
        array(
            'documento' => 'documento',
            'descripcion' => 'descripcion_td'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_NOVEDAD_VENCIMIENTO' => array(
            'id_novedad_vencimiento,a' => array('!=' => array(-1)),
            'id_novedad_vencimiento,b' => array('=' => array('id_novedad_vencimiento')),
            'id_debito' => array('=' => array('id_debito')),
            'num_doc' => array('=' => array('num_doc')),
            'id_ts_td' => array('=' => array('id_ts_td')),
            'fecha_novedad' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $fields_orderBy = array(
        'fecha_novedad', 'id_debito'
    ); //campos para el ordenamiento de la consulta
    protected $table_field_obligatory = array('id_debito', 'fecha_vence_ant', 'fecha_vence_act'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_novedad_vencimiento'; //identificador de la tabla
    protected $id_names = array('id_novedad_vencimiento'); //llave primaria
    protected $field_names = array('id_debito', 'fecha_vence_ant', 'fecha_vence_act', 'num_doc', 'id_ts_td',
        'fecha_novedad', 'observaciones', 'usuariolog',
        'observaciones_ant', 'observaciones_act'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_NOVEDAD_VENCIMIENTO'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_novedad_vencimiento'; //identificador unico de la tabla

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuariolog'] = $request['username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Actualiza debito y vencimiento - 20190926
             */
            try {

                $id_debito = $list_data_post[0]['id_debito'];
                $fecha_vence_act = $request['fecha_vence_act'];                
                //nuevo campo para actualizar - 20201106::LAVILA
                $observaciones_act = $request['observaciones_act'];

                //ca_debito
                $sql = <<<EOD
update ca_debito set fecha_vencimiento = to_date('$fecha_vence_act','yyyy-mm-dd'), 
    observaciones = '$observaciones_act'
    where id_debito = $id_debito 
EOD;
                $this->conn->execute($sql);

                //ca_debito_detalle
                $sql = <<<EOD
update ca_debito_detalle set 
    observaciones = '$observaciones_act'
    where id_debito = $id_debito 
EOD;
                $this->conn->execute($sql);

                //ca_vencimientos
                $sql = <<<EOD
update ca_vencimientos set fecha_vence = to_date('$fecha_vence_act','yyyy-mm-dd') where id_debito = $id_debito 
EOD;
                $this->conn->execute($sql);

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $ex) {
                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
